function eq=GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem)

global prec prec2

% assumption: the log of entry cost is normally distributed with mean:
% log(entrycostM)-.5*entrycostV^2/2, and variance entrycostV^2

%%% code with elastic entry AND elastic labor

meanlogk = log(entrycostM)-.5*entrycostV^2/2 ;
stdlogk = entrycostV ;

wageD = .01 ; wageU = 20 ;
while abs(wageU-wageD)>prec
    
    wagetry = (wageU+wageD)/2 ;
    valuez00 = calculvalue(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
    kstar = valuez00 ;
    if kstar>0
        numentrants = Ebar*normcdf(log(kstar),meanlogk,stdlogk) ;
        M = numentrants/lambda ;
        N1 = totalNs(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
        N = M*N1 ;
        Y1 = totalYs(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        Y = M*Y1 ;
        Totentrycost = Ebar*exp(meanlogk+.5*stdlogk^2)*normcdf( (log(kstar)-meanlogk-stdlogk^2)/stdlogk,0,1 );
        C = Y - Totentrycost ;
        
        MRS = B*C*N^phi ;
        if C<0 % this means entry costs too large, too much entry, need to increase the wage, i.e.
            MRS = 1e12;
        end
    else
        MRS = Inf ;
    end
    
    if MRS>wagetry/(1+tg)
        wageD = wagetry ;
    else
        wageU = wagetry ;
    end
end

if abs(MRS-wagetry/(1+tg))>1e-4
    disp('problem: lab mkt not in equilibrium')
    disp(N)
    disp(MRS)
    eq = [0,0,0,0,0,0,0,0,0] ;
else    
    wage = wagetry ;
    Pi = Y - wage*N  ;
    Totentrycost = Ebar*exp(meanlogk+.5*stdlogk^2)*normcdf( (log(kstar)-meanlogk-stdlogk^2)/stdlogk,0,1 );
    C = Y - Totentrycost ;
    eq = [Y,N,M,wage,Totentrycost,Pi,C,kstar,Totentrycost/numentrants] ;
end
% normcdf(log(kstar),meanlogk,stdlogk)] ;
% eq = [Y,N,M,wage,Totentrycost,Pi,C,kstar];
