function eq=GEcalcELASTICENTRY_INELASTICLABOR(entrycostM,entrycostV,Ebar,AggregateN,alpha,nbar,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);

% assumption: the log of entry cost is normally distributed with mean:
% log(entrycostM)-.5*entrycostV^2/2, and variance entrycostV^2

%%% code with elastic entry, inelastic labor supply

global prec prec2

meanlogk = log(entrycostM)-.5*entrycostV^2/2 ;
stdlogk = entrycostV ;

wageD = .01 ; wageU = 20 ; 
while abs(wageU-wageD)>prec
    
    wagetry = (wageU+wageD)/2 ;
    valuez00 = calculvalue(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
    kstar = valuez00 ;    
    if kstar>0
        numentrants = Ebar*normcdf(log(kstar),meanlogk,stdlogk) ;
        M = numentrants/lambda ;
        N1 = totalNs(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
        N = M*N1 ;
    else
        N = Inf ;
    end
    
    if N>AggregateN
        wageD = wagetry ;
    else
        wageU = wagetry ;
    end
end

if abs(N-AggregateN)>prec2
    disp('problem: lab mkt not in equilibrium')
    disp(N-AggregateN)
    beep; beep; beep; beep ;
    eq = [0,0,0,0,0,0,0,0,0] ;
else    
    wage = wagetry ;
    Y1 = totalYs(alpha,nbar,wagetry,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
    Y = M*Y1 ;
    Totentrycost = Ebar*exp(meanlogk+.5*stdlogk^2)*normcdf( (log(kstar)-meanlogk-stdlogk^2)/stdlogk,0,1 );
    C = Y - Totentrycost ;
    Pi = Y - wage*N  ;
    eq = [Y,N,M,wage,Totentrycost,Pi,C,kstar,Totentrycost/numentrants] ; % normcdf(log(kstar),meanlogk,stdlogk)] ;
end