

clear all ; close all ; clc ;

global prec prec2

for nummodel=1:9 ;
    
    
    %%%%%%%%%%%%%%%%%%%%%%
    % Policy Experiments %
    %%%%%%%%%%%%%%%%%%%%%%
    
    % copy-paste excel table from sps.ods:
    
    AS = [0.0301	0.0030	0.0520	0.0211	1.0281	0.0004
    0.0293	0.0029	0.0527	0.0134	1.2908	0
    0.0302	0.0032	0.0504	0.0324	0	0.0015
    0.0296	0.0013	0.0230	0.0177	0.4516	0.0001
    0.0300	0.0044	0.0766	0.0210	1.4634	0.0004    
    0.0211	0.0020	0.0416	0.0218	0.9021	0.0004
    0.0230	0.0011	0.0291	0.0148	0.6059	0.0001
    0.0276	0.0025	0.0480	0.0270	0.9475	0.0008
    0.0226	0.0015	0.0370	0.0483	0.8959	0.0002] ;

    ALPHAvec = [0.66,0.66,0.66,0.85,0.50,0.69,0.78,0.66,0.74] ;
    
    paramcompSUNK = AS(:,5) ;
    paramcompTAU = AS(:,6) ;
    paramcompLAMBDA = AS(:,1) ;
    paramcompMU = AS(:,2) ;
    paramcompSIGMA = AS(:,3) ;
    paramcompMRE = AS(:,4) ;
    
    r                                   = 0.05 ;
    nbar                                = 49.01 ;
    wage                                = 1 ;
    cf                                  = 0 ;
    tau.cf                              = 0 ;
    alpha                               = ALPHAvec(nummodel) ;
    
    lambda                          = paramcompLAMBDA(nummodel) ;
    sigma.z                         = paramcompSIGMA(nummodel) ;
    mu.z                            =  paramcompMU(nummodel) ;
    tau.wage                        = paramcompTAU(nummodel) ;
    sunkcost                        = paramcompSUNK(nummodel) ;
    
    sigma.mre = paramcompMRE(nummodel) ;
    
    taux.wage= 0 ; taux.cf = 0 ;sunkcostx = 0 ;
    % for experiment: pushing the threshold to 75
    nbarbar = 74.01 ;
    
    % precision for calculation:
    prec = 1e-13 ;
    prec2 = 1e-7 ;
    
    disp('==============================================================')
    disp('GE, log utility, inelastic labor')
    for rem=0:1;
        AggregateN = .25 ; targetnoverm1 = 7.5 ; targetwage = 1 ;
        disp('MODEL:')
        disp(nummodel)
        disp('Calibrate the level of entry costs and z0 to generate a wage=1, target N/M')
        calibrationINELASTICrrr
        disp('z0:')
        z0
        disp('entry cost:')
        entrycost
        
        eqBF = GEcalcINELASTIC(entrycost,AggregateN,alpha,nbar,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        eqAF = GEcalcINELASTIC(entrycost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);

        %         [Y,N,M,wage,lambda*entrycost*M,Pi,C] ;
        % holding the wage fixed:
        eqpepe = [eqBF(3)*totalYs(alpha,nbar,eqBF(4),taux,lambda,r,cf,sigma,mu,sunkcostx,z0,rem), eqBF(3)*totalNs(alpha,nbar,eqBF(4),taux,lambda,r,cf,sigma,mu,sunkcostx,z0),...
            eqBF(3), eqBF(4), 0,0,eqBF(3)*totalYs(alpha,nbar,eqBF(4),taux,lambda,r,cf,sigma,mu,sunkcostx,z0,rem) - lambda*entrycost*eqBF(3)] ;
        
    
        % keeping entry fixed:
        eqN = GEcalcINELASTICn(entrycost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,sunkcostx,z0,rem,eqBF(3));

        eq_wtaxonly = GEcalcINELASTIC(entrycost,AggregateN,alpha,nbar,tau,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        eq_wsunkonly = GEcalcINELASTIC(entrycost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,sunkcost,z0,rem);

        eq_wtaxonly_fixedentry = GEcalcINELASTICn(entrycost,AggregateN,alpha,nbar,tau,lambda,r,cf,sigma,mu,sunkcostx,z0,rem,eqBF(3));
        eq_wsunkonly_fixedentry = GEcalcINELASTICn(entrycost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,sunkcost,z0,rem,eqBF(3));
        eq_applyall_fixedentry = GEcalcINELASTICn(entrycost+sunkcost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,0,z0,rem,eqBF(3));
        eq_apply75_fixedentry = GEcalcINELASTICn(entrycost,AggregateN,alpha,nbarbar,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem,eqBF(3));
        
        % apply to all:
        eqAF2 = GEcalcINELASTIC(entrycost+sunkcost,AggregateN,alpha,nbar,taux,lambda,r,cf,sigma,mu,0,z0,rem); % evbd pays sunk cost at entry; ta
        % apply to 75:
        eqAF3 = GEcalcINELASTIC(entrycost,AggregateN,alpha,nbarbar,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        %     dispresults
        if rem==0
            resultsPE.inelasticlabor.transfers.basic = eqAF./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.entryfixed.basic = eqN./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.apply75 = eqAF3./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.applyall = eqAF2./eqBF*100-100 ;

            
            resultsPE.inelasticlabor.transfers.pepe = eqpepe./eqBF*100-100 ;
            
            resultsPE.inelasticlabor.transfers.entryfixed.applyall = eq_applyall_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.entryfixed.apply75 = eq_apply75_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.entryfixed.removetaxonly = eq_wsunkonly_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.transfers.entryfixed.removesunkcostonly = eq_wtaxonly_fixedentry./eqBF*100-100 ;
        else
            resultsPE.inelasticlabor.realcost.basic = eqAF./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.entryfixed.basic = eqN./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.apply75 = eqAF3./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.applyall = eqAF2./eqBF*100-100 ;
            
            resultsPE.inelasticlabor.realcost.pepe = eqpepe./eqBF*100-100 ;

            resultsPE.inelasticlabor.realcost.entryfixed.applyall = eq_applyall_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.entryfixed.apply75 = eq_apply75_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.entryfixed.removetaxonly = eq_wsunkonly_fixedentry./eqBF*100-100 ;
            resultsPE.inelasticlabor.realcost.entryfixed.removesunkcostonly = eq_wtaxonly_fixedentry./eqBF*100-100 ;
        end
        %     per_e3(:,:,rem+1) = per ;
        % note: here the labor tax does not matter at all since labor supply
        % inelastic.
    end
    
    
    disp('==============================================================')
    disp('Elastic labor')
    for rem=0:1;
        phi = 1 ; %  Elasticity of labor
        disp('Calibrate the level of entry costs and z0 and B to generate a wage=1 and N=.25')
        targetN = .25 ; targetwage = 1 ; tg = 0 ; targetnoverm1 = 7.5 ;
        calibrationELASTICrrr ;
        disp('z0:')
        z0
        disp('B:')
        B
        disp('entry cost:')
        entrycost
        
        eqBF = GEcalc(entrycost,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        eqAF = GEcalc(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        eqN = GEcalcn(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem,eqBF(3));
        eq_wtaxonly = GEcalc(entrycost,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        eq_wsunkonly = GEcalc(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        tg = tau.wage ;
        eqAF2 = GEcalc(entrycost+sunkcost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,0,z0,rem);
        tg = 0 ;
        eqAF3 = GEcalc(entrycost,phi,B,alpha,nbarbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        
        if rem==0
            resultsPE.elasticlabor.transfers.basic = eqAF./eqBF*100-100 ;
            resultsPE.elasticlabor.transfers.entryfixed.basic = eqN./eqBF*100-100 ;
            resultsPE.elasticlabor.transfers.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.elasticlabor.transfers.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.elasticlabor.transfers.apply75 = eqAF3./eqBF*100-100 ;
            resultsPE.elasticlabor.transfers.applyall = eqAF2./eqBF*100-100 ;
        else
            resultsPE.elasticlabor.realcost.basic = eqAF./eqBF*100-100 ;
            resultsPE.elasticlabor.realcost.entryfixed.basic = eqN./eqBF*100-100 ;
            resultsPE.elasticlabor.realcost.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.elasticlabor.realcost.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.elasticlabor.realcost.apply75 = eqAF3./eqBF*100-100 ;
            resultsPE.elasticlabor.realcost.applyall = eqAF2./eqBF*100-100 ;
        end
    end
    
    disp('==============================================================')
    disp('Entry cost in labor units')
    for rem=0:1;
        phi = 1 ; %  Elasticity of labor
        disp('Calibrate the level of entry costs and z0 and B to generate a wage=1 and N=.25')
        targetN = .25 ; targetwage = 1 ; tg = 0 ; targetnoverm1 = 7.5 ;
        calibrationELASTICrrrENTRYCOSTLABOR ;
        disp('z0:')
        z0
        disp('B:')
        B
        disp('entry cost:')
        entrycost
        
        eqBF = GEcalcLABORENTRY(entrycost,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        eqAF = GEcalcLABORENTRY(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        %         eqN = GEcalcn(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem,eqBF(3));
        eq_wtaxonly = GEcalcLABORENTRY(entrycost,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        eq_wsunkonly = GEcalcLABORENTRY(entrycost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        %         tg = tau.wage ;
        %         eqAF2 = GEcalcLABORENTRY(entrycost+sunkcost,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,0,z0,rem);
        tg = 0 ;
        eqAF3 = GEcalcLABORENTRY(entrycost,phi,B,alpha,nbarbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        
        if rem==0
            resultsPE.entrycostlabor.elasticlabor.transfers.basic = eqAF./eqBF*100-100 ;
            %             resultsPE.entrycostlabor.elasticlabor.transfers.entryfixed = eqN./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.transfers.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.transfers.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.transfers.apply75 = eqAF3./eqBF*100-100 ;
            %             resultsPE.entrycostlabor.elasticlabor.transfers.applyall = eqAF2./eqBF*100-100 ;
        else
            resultsPE.entrycostlabor.elasticlabor.realcost.basic = eqAF./eqBF*100-100 ;
            %             resultsPE.entrycostlabor.elasticlabor.realcost.entryfixed = eqN./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.realcost.removetaxonly = eq_wsunkonly./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.realcost.removesunkcostonly = eq_wtaxonly./eqBF*100-100 ;
            resultsPE.entrycostlabor.elasticlabor.realcost.apply75 = eqAF3./eqBF*100-100 ;
            %             resultsPE.entrycostlabor.elasticlabor.realcost.applyall = eqAF2./eqBF*100-100 ;
        end
    end        
    eval(strcat(strcat('save resultsFX',num2str(nummodel)),' resultsPE' ))
end