

% calibrate z0 and entry cost to match the targetwage and targetnoverm
targetM = AggregateN/targetnoverm ;

[uz,oz,hz,beta1,beta2]=thresholds(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,1) ; % z0 doesn't matter here
z0D = -2 ;
z0U = uz*.999 ;

wage = targetwage ;

if (totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0U)-targetnoverm1)*(totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0D)-targetnoverm1)>0
    disp('problem with calibration elastic-inelastic: Bounds invalid')
    beep; beep; beep; beep;
    break ;
end

while abs(z0U-z0D)>prec
    z0 = (z0U+z0D)/2 ;    
    N1 = totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
    if N1<targetnoverm
        z0D = z0 ;
    else
        z0U = z0 ;
    end
end

if abs(N1-targetnoverm)>prec2
    disp('error in calibration elastic-inelastic 1')
    beep; beep; beep; beep; 
    break
end

N1 = totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0) ;    
valuez00 = calculvalue(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0) ;

if entry_label_goods==1
    kstar = valuez00 ;
else
    kstar = valuez00/wage ;
end

% find entry cost to make M = targetM (and hence fit N)
entrycostU = 1e3 ; entrycostD = 1e-6 ;
while abs(entrycostU-entrycostD)>prec
    
    entrycostM = .5*(entrycostU+entrycostD) ;
    meanlogk = log(entrycostM)-.5*entrycostV^2/2 ;
    stdlogk = entrycostV ;
    if kstar>0
        numentrants = Ebar*normcdf(log(kstar),meanlogk,stdlogk) ;
        M = numentrants/lambda ;    
    else
        M = Inf ; 
    end
        
    if M>targetM
        entrycostD = entrycostM ;
    else
        entrycostU = entrycostM ;
    end
end

if abs(M-targetM)>prec2
    disp('error in calibration elastic-inelastic 2')
    beep; beep; beep; beep; 
    break
end

eq = GEcalcELASTICENTRY_INELASTICLABOR(entrycostM,entrycostV,Ebar,AggregateN,alpha,nbar,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem) ;
    
if abs(eq(4)-targetwage)+abs(eq(2)/eq(3)-targetnoverm)>prec2*2
    disp('error in calibration elastic-inelastic 3')
    beep; beep; beep; beep; 
    break
end
        
