
% set z0 and entrycost and B (leisure pref) to match targetwage(=1) and N/M
% (avg employees per firm) and N = .25 
[uz,oz,hz,beta1,beta2]=thresholds(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,1) ; % z0 doesn't matter here
z0D = -2 ;
z0U = uz*.999 ;


wage = targetwage ;

if (totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0U)-targetnoverm1)*(totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0D)-targetnoverm1)>0
    disp('problem with calibration elastic 0: Bounds invalid')
    beep; beep; beep; beep;
    break ;
end


while abs(z0U-z0D)>prec    
    z0 = (z0U+z0D)/2 ;    
    N1 = totalNs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
    if N1>targetnoverm1
        z0U = z0 ;
    else
        z0D = z0 ;
    end
end

if abs(N1-targetnoverm1)>prec2
    disp('error in calibration elastic 1 ')
    beep; beep; beep; beep; 
    break
end

entrycostU = 1e3 ; entrycostD = 1e-6 ;
valuez00 = calculvalue(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0);

while abs(entrycostU-entrycostD)>prec    
    entrycost = .5*(entrycostU+entrycostD) ;   
    if valuez00>entrycost
        entrycostD = entrycost ;
    else
        entrycostU = entrycost ;
    end
end
    
if abs(entrycost-valuez00)>prec2
    disp('error in calibration elastic 2')
    beep; beep; beep; beep; 
    break
end

% w/(1+t) = B C N^phi = B (Y1- lambda*entrycost)*N1^phi*M^(1+phi)
Y1 = totalYs(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
M = targetN/targetnoverm1 ;
B = targetwage/((1+tg)*(Y1-lambda*entrycost)*N1^phi*M^(1+phi)) ;    


eq = GEcalc(entrycost,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem) ;
% eq = [Y,N,M,wage,lambda*entrycost*M,Pi,C] ;
% valuez00 = calculvalue(alpha,nbar,wage,tau,lambda,r,cf,sigma,mu,sunkcost,z0);
if abs(eq(4)-targetwage)+abs(eq(2)-targetN)+abs(eq(2)/eq(3)-targetnoverm1)>3*prec2
    disp('error in calibration elastic 3')
    beep; beep; beep; beep;
    break
end
