module GLOBALVARIABLES

  implicit none

  REAL(8), PARAMETER                         :: alpha           = 0.66d0
  INTEGER, PARAMETER                         :: N               = 50000

  real(8)                                    :: oldresid

  INTEGER, parameter                         :: noini           = 1
  integer, parameter                         :: sunk            = 0
  integer, parameter                         :: both            = 0
  integer, parameter                         :: weightmatrix    = 1
  integer, parameter                         :: gfort           = 1
  integer, parameter                         :: poisson         = 0

  INTEGER, PARAMETER                         :: nsps            = 5+both
  INTEGER, PARAMETER                         :: naps            = 11

  INTEGER, PARAMETER                         :: wfig            = 0

  INTEGER, PARAMETER                         :: dp              = SELECTED_REAL_KIND(14, 60)

  INTEGER                                    :: int_rn    

  integer(4)                                 :: int_int      

  REAL(dp), DIMENSION(1:nsps)                :: theta

  REAL(8), PARAMETER                         :: dt              = 0.02
  INTEGER, parameter                         :: one_period      = nint(1/dt)
  INTEGER, PARAMETER                         :: T               = 7*nint(1/dt)

  integer, parameter                         :: widthbin        = 3

  REAL(8), PARAMETER                         :: tol             = 1E-008

  REAL(8), DIMENSION(1:N)                    :: s_y
  REAL(8), DIMENSION(1:N,1:T)                :: shocks_n, shocks_exit
  integer(4), DIMENSION(1:N,1:T)             :: s_exitprime

  REAL(8), DIMENSION(1:N)                    :: logMRE
  REAL(8), DIMENSION(1:N,7)                  :: logMREprime, MREprime

  REAL(8), DIMENSION(1:naps)                 :: empiricalmoments, v_aps
  REAL(8), DIMENSION(1:500,1:naps)           :: MBaps

  REAL(8), DIMENSION(1:N)                    :: prv_1
  REAL(8), DIMENSION(1:N)                    :: prv_2
  REAL(8), DIMENSION(1:N)                    :: prv_prime_1
  REAL(8), DIMENSION(1:N)                    :: prv_prime_2

  REAL(8), DIMENSION(1:N)                    :: MRE_poisson
  REAL(8), DIMENSION(1:N)                    :: MRE_prime_poisson

  REAL(8), PARAMETER                         :: lb_1            = 0.01d0               ! lambda
  REAL(8), PARAMETER                         :: lb_2            = -0.005d0              ! mu
  REAL(8), PARAMETER                         :: lb_3            = 0.01d0               ! sigma
  REAL(8), PARAMETER                         :: lb_4            = 0.005d0              ! sigma mre
  REAL(8), PARAMETER                         :: lb_5            = 0.000000001d0        ! tau or F
  REAL(8), PARAMETER                         :: lb_6            = 0.000000001d0        ! tau or F

  REAL(8), PARAMETER                         :: ub_1            = 0.05d0       ! lambda
  REAL(8), PARAMETER                         :: ub_2            = 0.007d0       ! mu
  REAL(8), PARAMETER                         :: ub_3            = 0.1d0        ! sigma
  REAL(8), PARAMETER                         :: ub_4            = 0.05d0       ! sigma mre
  REAL(8)                                    :: ub_5                           ! F
  REAL(8)                                    :: ub_6                           ! tau

  integer                                    :: ii, kk, gg, gsunk, gsigmamre, it

  REAL(8), PARAMETER                         :: r             = 0.05d0
  REAL(8), PARAMETER                         :: nbar          = 49.01d0

  integer(4), PARAMETER                      :: ncond         = 55

  REAL(8), PARAMETER                         :: wage          = 1.0d0
  REAL(8), PARAMETER                         :: cf            = 0
  REAL(8), PARAMETER                         :: tau_cf        = 0

  REAL(8)                                    :: num_p1
  REAL(8)                                    :: num_p2
  REAL(8)                                    :: num_p3
  REAL(8)                                    :: num_p4
  REAL(8)                                    :: num_p5
  REAL(8)                                    :: num_p6
  REAL(8)                                    :: num_p7

  REAL(8), DIMENSION(1:N)                    :: n_p1, o_p1
  REAL(8), DIMENSION(1:N)                    :: n_p2, o_p2
  REAL(8), DIMENSION(1:N)                    :: n_p3, o_p3
  REAL(8), DIMENSION(1:N)                    :: n_p4, o_p4
  REAL(8), DIMENSION(1:N)                    :: n_p5, o_p5
  REAL(8), DIMENSION(1:N)                    :: n_p6, o_p6
  REAL(8), DIMENSION(1:N)                    :: n_p7, o_p7

  REAL(8)                                    :: nxx, zxx

  REAL(8)                                    :: int1, int2, int3
  REAL(8)                                    :: int4, int5, int6
  REAL(8)                                    :: int7, int8

  REAL(8)                                    :: fraction_gtn100
  REAL(8)                                    :: share_n_gtn100
  REAL(8)                                    :: share_o_gtn100

  REAL(8)                                    :: fraction_gtn200
  REAL(8)                                    :: share_n_gtn200
  REAL(8)                                    :: share_o_gtn200

  real(8)                                    :: time_begin, time_end

contains

! --------------------------------------------------------------------

   function sps_trans(x,xmin,xmax)

    IMPLICIT NONE

    real(8)                                 :: sps_trans
    REAL(8), INTENT(IN)                     ::  x
    REAL(8), INTENT(IN)                     ::  xmin
    REAL(8), INTENT(IN)                     ::  xmax

    sps_trans                               = (xmax-xmin)*exp(x)/(1+exp(x)) + xmin

  end function sps_trans

! --------------------------------------------------------------------

end module GLOBALVARIABLES
