PROGRAM main_naps

  USE qsort_c_module
  USE RANDOM
  use random_nsn

  use GLOBALVARIABLES

  USE STATISTICS
  USE MATRIX

  IMPLICIT NONE
  
  REAL (dp)                             :: object, p(nsps), simp, step(nsps), stopcr, var(nsps)
  REAL (dp)                             :: func
  INTEGER                               :: ier, iprint, iquad, maxf, nloop, nop
  LOGICAL                               :: first

  real(8)                               :: int_1, int_2, int_3, int_4

  real(dp), dimension(nsps,noini)       :: p0

  integer                               :: bb

  INTERFACE
     SUBROUTINE objfun(p, func)
       IMPLICIT NONE
       INTEGER, PARAMETER     :: dp                = SELECTED_REAL_KIND(14, 60)
       REAL (dp), INTENT(IN)  :: p(:)
       REAL (dp), INTENT(OUT) :: func
     END SUBROUTINE objfun
  END INTERFACE

open(2, file = "inp.txt",status="old")
read(2,*) int_rn
close(2)

call CPU_TIME( time_begin )

oldresid                                = 1000000

if ( both == 1) then
   ub_5                                 = 1.5d0
   ub_6                                 = 0.01d0
else
   if (sunk == 1) then
      ub_5                              = 1.5d0
   else
      ub_5                              = 0.01d0
   end if
end if

   Call Set_Seed(1+int_rn,7+int_rn,1+int_rn,5+int_rn)

   DO ii = 1, N

      s_y(ii)                   = Sample_Uniform(0.0d0,1.0d0)

         if (poisson<=0) then
            logMRE(ii)          = Sample_Normal(0.0d0,1.0d0)
         end if

      DO kk = 1,T
         shocks_n(ii,kk)        = Sample_Normal(0.0d0,1.0d0)
         shocks_exit(ii,kk)     = Sample_Uniform(0.0d0,1.0d0)
      END DO

      DO kk = 1,7
         logMREprime(ii,kk)  = Sample_Normal(0.0d0,1.0d0)
      END DO

   END DO

   call QsortC(s_y)

p(1) = Sample_Uniform(lb_1,ub_1)
p(2) = Sample_Uniform(lb_2,ub_2)
p(3) = Sample_Uniform(lb_3,ub_3)
p(4) = Sample_Uniform(lb_4,ub_4)
p(5) = Sample_Uniform(lb_5,ub_5)

if ( both == 1 ) then
   p(nsps) = Sample_Uniform(lb_6,ub_6)
end if

p(1) = log(p(1)-lb_1) - log(ub_1-p(1))
p(2) = log(p(2)-lb_2) - log(ub_2-p(2))
p(3) = log(p(3)-lb_3) - log(ub_3-p(3))
p(4) = log(p(4)-lb_4) - log(ub_4-p(4))
p(5) = log(p(5)-lb_5) - log(ub_5-p(5))

if ( both == 1 ) then
   p(nsps) = log(p(nsps)-lb_6) - log(ub_6-p(nsps))
end if

call objfun(p,func)
STOP

END PROGRAM main_naps

!------------------------------------------------------------------------------------------

SUBROUTINE objfun(p,func)

  use GLOBALVARIABLES

  USE RANDOM
  USE STATISTICS
  USE MATRIX
  use random_nsn
  USE qsort_c_module

    IMPLICIT NONE

    REAL (dp), INTENT(IN)                       :: p(:)
    REAL (dp), INTENT(OUT)                      :: func

    ! local variables

    INTEGER, PARAMETER                         :: maxit = 1000 

    INTEGER                                    :: i, j, iold
    real(8)                                    :: int_1,int_2, int_3, int_4
    integer(4)                                 :: in

    REAL(8)                                    :: sigma_z
    REAL(8)                                    :: mu_z
    REAL(8)                                    :: z0
    REAL(8)                                    :: tau_wage
    REAL(8)                                    :: F
    REAL(8)                                    :: lambda
    REAL(8)                                    :: sigma_MRE

    REAl(8)                                    :: uz, oz, hz
    REAL(8), DIMENSION(1:N)                    :: MRE, s_z, s_s, s_n, s_o

    INTEGER(4), DIMENSION(1:N)                 :: s_nfloor

    REAL(8), DIMENSION(1:N,1:T)                :: dz
    REAL(8), DIMENSION(1:N,1:T)                :: s_zprime, s_sprime, s_nprime
    INTEGER(4), DIMENSION(1:N,1:T)             :: s_id
    REAL(8), DIMENSION(1:N)                    :: s_nwme

    REAL(8), DIMENSION(1:N,6)                  :: diff
    integer(4), DIMENSION(1:N,6)               :: count_diff
    REAL(8), DIMENSION(1:N*6,1)                :: vec_diff
    integer(4), DIMENSION(1:N*6,1)             :: vec_count_diff

    integer(4), DIMENSION(1:N,1:7)             :: n_panel, n_panel_nome, id_panel
    integer(4), DIMENSION(N*7,1)               :: vec_n_panel_nome, vec_n_panel, vec_id_panel

    integer(4), DIMENSION(1:N,1:7,1:7)         :: n_panel_ub, n_panel_nome_ub
    integer(4), DIMENSION(N*7*7,1)             :: vec_n_panel_nome_ub, vec_n_panel_ub

    integer(4), DIMENSION(1:N,1:7,1:7)         :: n_panel_ub_U, n_panel_nome_ub_U
    integer(4), DIMENSION(N*7*7,1)             :: vec_n_panel_nome_ub_U, vec_n_panel_ub_U

    REAL(8), DIMENSION(5,5)                    :: AA
    REAL(8), DIMENSION(5,1)                    :: BB, sol
    REAL(8)                                    :: beta1, beta2, C1, C2, C3, C4, C5, C6, C7,&
         cdf_below_athz,  cdf_below_atz0
    REAL(8)                                    :: y0, hy
    REAL(8), ALLOCATABLE, DIMENSION(:,:)       :: y_before_belowz0
    REAL(8)                                    :: fval, fjac

    REAL(8)                                    :: bin_40t46, bin_47t49, bin_50t52, bin_53t59, bin_40t60
    REAL(8)                                    :: bin_40t46_cond, bin_47t49_cond, bin_50t52_cond, bin_53t59_cond, bin_40t60_cond

    REAL(8)                                    :: bin_40t46_cond_ub, bin_47t49_cond_ub, bin_50t52_cond_ub
    REAL(8)                                    :: bin_53t59_cond_ub, bin_40t60_cond_ub

    REAL(8), DIMENSION(1:naps)                 :: theoreticalmoments
    REAL(8)                                    :: median, NET, residuals
    REAL(8)                                    :: v_ln, v_dz, m_ln

    REAL(8)                                    :: residzexit1, residzexit0, residhz, R1, R2, JJ, zexit1, zexit0
    REAL(8)                                    :: S1, S0, Vhz1, tauwage, taucf 
    REAL(8)                                    :: FOChzdS0, FOCzexit0dS0, FOCzexit0dhz, FOChzdhz
    REAL(8), DIMENSION(2,2)                    :: focjac
    REAL(8), DIMENSION(2)                      :: focresid, temp
    REAL(8), DIMENSION(7,7)                    :: mc
    REAL(8), DIMENSION(7)                      :: mb, vc
    REAL(8)                                    :: cdf_before_athz, cdf_before_atz0, cdf_after_athz, cdf_after_atinf
    REAL(8)                                    :: index_before_athz, index_before_atz0, index_after_athz

    theta(1)        = sps_trans(p(1),lb_1,ub_1)
    theta(2)        = sps_trans(p(2),lb_2,ub_2)
    theta(3)        = sps_trans(p(3),lb_3,ub_3)
    theta(4)        = sps_trans(p(4),lb_4,ub_4)
    theta(5)        = sps_trans(p(5),lb_5,ub_5)

if (both == 1) then
   theta(nsps)        = sps_trans(p(nsps),lb_6,ub_6)
end if

lambda          = theta(1)
mu_z            = theta(2)
sigma_z         = theta(3)
sigma_mre       = theta(4)

if (sunk == 1) then
   F               = theta(5)
   tau_wage        = 0d0
else
   tau_wage        = theta(5)
   F               = 0d0
end if

if (both == 1) then
   F               = theta(nsps-1)
   tau_wage        = theta(nsps)
end if

DO ii = 1, N
   DO kk = 1,T
      if ( shocks_exit(ii,kk) < lambda*dt ) then
         s_exitprime(ii,kk)     = 1
      else
         s_exitprime(ii,kk)     = 0         
      end if
   END DO
END DO

z0              = ( 1 - alpha ) * log(19d0) + log(wage) - log(alpha) ! 1.4166

beta1           = ( mu_z - sqrt(mu_z**2 + 2 * lambda * sigma_z**2) ) / sigma_z**2
beta2           = ( mu_z + sqrt(mu_z**2 + 2 * lambda * sigma_z**2) ) / sigma_z**2 

if ( (1/(1-alpha)) > -beta1 ) then
   func = 9000009d0
   GO TO 12345
end if

    !
    ! Derive Optimal Policies uz, oz, hz
    !
    !

    uz = log( (nbar**(1-alpha)) * wage / alpha )

    !
    ! solve for oz
    !
 
if (tau_wage>0) then
    oz = uz*3/2
    i  = 1
    DO
       fval = FOC_residual(oz, alpha, cf, lambda, mu_z, nbar, &
            uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage, 1,1)
       fjac = FOC_residual(oz, alpha, cf, lambda, mu_z, nbar, &
            uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage, 1,2)
       IF ( (ABS(fval) < tol) .OR. ( i > maxit ) ) EXIT
       oz   = oz - fval/fjac
       IF ( oz < uz ) THEN
          oz = uz + i
       END IF
       i = i + 1
    END DO
    
    IF (ABS(fval) > tol) THEN
       WRITE(*,*) 'iter # ', i, 'oz ', oz, 'fval ', fval, 'fjac ', fjac 
    END IF

    IF (ABS(fval) > tol) THEN
       WRITE(*,*) 'oz: NO CONVERGENCE '
       WRITE(*,*) 'fval', fval
       WRITE(*,*) 'i', i
    END IF
else
   oz = uz
end if

    !
    ! define the appropriate discount rate
    ! 

    JJ          = sqrt(mu_z**2 + 2 * (r+lambda) * sigma_z**2)
    R1          = - ( mu_z + JJ ) / sigma_z**2
    R2          = - ( mu_z - JJ ) / sigma_z**2

    !
    ! solve for hz
    !

if (F>0) then
    i  = 1
    hz = 4*oz

    DO
       fval = FOC_residual(hz, alpha, cf, lambda, mu_z, nbar, &
            uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage, 3,1)
       fjac = FOC_residual(hz, alpha, cf, lambda, mu_z, nbar, &
            uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage, 3,2)
       hz   = hz - fval/fjac
       IF ( (ABS(fval) < tol) .OR. ( i > maxit ) ) EXIT
       i = i + 1 
    END DO
else
   hz = oz
end if
    
IF (ABS(fval) > tol) THEN
   WRITE(*,*) 'hz: NO CONVERGENCE '
   WRITE(*,*) 'fval', fval
   WRITE(*,*) 'i', i
END IF

IF ( (oz<uz) .OR. (hz < uz ) .OR. (hz < oz ) .or. isnan(uz) .or. isnan(oz) .or. isnan(hz) ) THEN
   WRITE(*,*) ''
   WRITE(*,*) 'ERROR WRONG POLICIES'
   write(*,*) 'uz', uz
   write(*,*) 'oz', oz
   write(*,*) 'hz', hz
   WRITE(*,*) ''
   func = 9999999d0
   GO TO 12345
END IF

  !
  ! XS
  !

  AA(:,:)   = 0d0
  BB(:,:)   = 0d0

  BB(4,1)   = 1 ;

  AA(1,1) = exp(beta2*z0) ;
  AA(1,2) = -exp(beta1*z0) ;
  AA(1,3) = -exp(beta2*z0) ;

  AA(2,2) = exp(beta1*hz) ;
  AA(2,3) = exp(beta2*hz) ;

  AA(3,4) = exp(beta2*hz) ;
  AA(3,5) = -exp(beta1*hz) ;

  AA(4,1) = 1/beta2*exp(beta2*z0) ;
  AA(4,2) = 1/beta1*(exp(beta1*hz)-exp(beta1*z0)) ;
  AA(4,3) = 1/beta2*(exp(beta2*hz)-exp(beta2*z0)) ;
  AA(4,4) = 1/beta2*exp(beta2*hz) ;
  AA(4,5) = -1/beta1*exp(beta1*hz) ;

  AA(5,4) = lambda*1/beta2*exp(beta2*hz) ;
  AA(5,5) = -lambda*1/beta1*exp(beta1*hz) ;
  AA(5,2) =  sigma_z**2/2*(beta1*exp(beta1*hz)) ;
  AA(5,3) =  sigma_z**2/2*(beta2*exp(beta2*hz)) ;

  sol = MATMUL( Matrix_Inverse(AA) , BB )
  C1 = sol(1,1) ;
  C2 = sol(2,1) ;
  C3 = sol(3,1) ;
  C4 = sol(4,1) ;
  C5 = sol(5,1) ;

  cdf_below_athz = 1-exp(beta1*(hz-z0)) ;
  cdf_below_atz0 = C1 * exp(beta2 * z0) / beta2 ;

  !
  ! Recovering s_z using the inverse cdf
  !

  y0                              = C1 * exp( beta2 * z0 ) / beta2 ;
  hy                              = C4 * exp( beta2 * hz ) / beta2 ;

  WHERE ( s_y<y0 )  ! z before below z0
     s_z                          = log( beta2 *s_y / C1 ) / beta2 ;
     s_s                          = 0
  END WHERE

  WHERE ( (s_y>=cdf_below_athz) .AND. (s_y<hy+cdf_below_athz)  )  ! z after below hz
     s_z                          = log( beta2 * ( s_y - cdf_below_athz ) / C4 ) / beta2 ;
     s_s                          = 1
  END WHERE

  WHERE ( s_y>=hy+cdf_below_athz )  ! z after above hz
     s_z                          = log( -beta1 * C4 * exp ( beta2 * hz ) / ( beta2* C5)&
          + beta1 *( s_y - cdf_below_athz ) / C5 + exp( beta1 * hz ) ) / beta1 ; 
     s_s                          = 1
  END WHERE

  WHERE ( (s_y>=y0) .AND. (s_y<cdf_below_athz)  )  ! z before above z0     
     s_z                          = 100000
     s_s                          = 0
  END WHERE

  DO i = 2, N !starts at 2 which assume there are zs before and below z0
     IF ( s_z(i) == 100000 ) THEN
        j = 1  
        DO
           s_z(i) = s_z(i-1)
           fval = invcdf_residual(s_z(i), beta1, beta2, hz, s_y(i), z0,1)
           fjac = invcdf_residual(s_z(i), beta1, beta2, hz, s_y(i), z0,2)
           s_z(i)   = s_z(i) - fval/fjac
           IF ( (ABS(fval) < tol) .OR. ( j > maxit ) ) EXIT
           j = j + 1 
        END DO
     END IF
  END DO

  !
  ! Recovering s_n
  !

  WHERE (s_z < uz )
     s_n                             = exp(s_z/(1-alpha))*((alpha/wage)**(1/(1-alpha)))
  END WHERE

  WHERE ( ( (s_z >= uz )  .AND. (s_s == 0 ) )  .OR. (  (s_z >= uz ) .AND. (s_z < oz ) .AND. (s_s == 1 ) ) )
     s_n                             = nbar
  END WHERE

  WHERE ( (s_z >= oz ) .AND. ( s_s == 1 ) )
     s_n                             = exp(s_z/(1-alpha))*((alpha/(wage*(1+tau_wage)))**(1/(1-alpha)))
  END WHERE

! MEASUREMENT ERROR

   MRE                          = exp( -0.5d0*(sigma_MRE**2) + sigma_MRE*logMRE )
   MREprime                     = exp( -0.5d0*(sigma_MRE**2) + sigma_MRE*logMREprime )   
   s_nwme                       = s_n*MRE

   s_nfloor                     = nint(s_nwme) ! rounded s_n with measurement error 

   bin_40t60                    = COUNT( (s_nfloor >= 40 ) .AND. (s_nfloor < 60) )
   bin_40t46                    = COUNT( (s_nfloor >= 40 ) .AND. (s_nfloor <= 46) ) / bin_40t60
   bin_47t49                    = COUNT( (s_nfloor >= 47 ) .AND. (s_nfloor <= 49) ) / bin_40t60
   bin_50t52                    = COUNT( (s_nfloor >= 50 ) .AND. (s_nfloor <= 52) ) / bin_40t60
   bin_53t59                    = COUNT( (s_nfloor >= 53 ) .AND. (s_nfloor <= 59) ) / bin_40t60

   !
   ! Compute Dynamics
   !

   ! simulate z and s dynamics
   
   s_zprime(:,1)                = s_z + mu_z * dt + sigma_z * sqrt(dt) * shocks_n(:,1)
   WHERE ( ( s_s == 1 ) .OR. ( s_zprime(:,1) > hz ) )
      s_sprime(:,1)             = 1
   ELSE WHERE
      s_sprime(:,1)             = 0
   END WHERE

   s_id(:,1) = 1

   DO j = 2,T
        s_zprime(:,j)           = s_zprime(:,j-1) + mu_z * dt + sigma_z * sqrt(dt) * shocks_n(:,j)
        !
        WHERE ( ( s_sprime(:,j-1) == 1 ) .OR. ( s_zprime(:,j) > hz ) )
           s_sprime(:,j)                          = 1
        ELSE WHERE
           s_sprime(:,j)                          = 0
        END WHERE
        !
        WHERE ( s_exitprime(:,j) == 1 )
           s_zprime(:,j)                        = z0
           s_sprime(:,j)                        = 0
           s_id(:,j)                            = s_id(:,j-1) + 1
        END WHERE
        !
        WHERE ( s_id(:,j-1) >  s_id(:,j) )
           s_id(:,j)                            = s_id(:,j-1) !  maxval( (/ s_id(i,j-1), s_id(i,j) /) )
        ELSE WHERE
           s_id(:,j)                            = s_id(:,j)
        END WHERE
   END DO

   ! simulate n dynamics

   DO j = 1,T

      WHERE ( s_zprime(:,j) < uz )
         s_nprime(:,j)                     = exp(s_zprime(:,j)/(1-alpha))*((alpha/wage)**(1/(1-alpha)))
      END WHERE

      WHERE ( (s_zprime(:,j) >= uz )  .AND. (s_sprime(:,j) == 0 ) )
         s_nprime(:,j)                     = nbar
      END WHERE

      WHERE ( (s_zprime(:,j) >= uz ) .AND. (s_zprime(:,j) < oz ) .AND. (s_sprime(:,j) == 1 ) )
         s_nprime(:,j)                     = nbar
      END WHERE

      WHERE ( (s_zprime(:,j) >= oz ) .AND. ( s_sprime(:,j) == 1 ) )
         s_nprime(:,j)                      = exp(s_zprime(:,j)/(1-alpha))*((alpha/(wage*(1+tau_wage)))**(1/(1-alpha)))
      END WHERE

   END DO

   !
   ! MEASUREMENT ERROR IN s_nprime
   !

 do ii=1,N
    n_panel(ii,1:7) = (/ nint(s_nprime(ii,one_period)*MREprime(ii,1)), nint(s_nprime(ii,2*one_period)*MREprime(ii,2)),& 
                         nint(s_nprime(ii,3*one_period)*MREprime(ii,3)), nint(s_nprime(ii,4*one_period)*MREprime(ii,4)),&
                         nint(s_nprime(ii,5*one_period)*MREprime(ii,5)), nint(s_nprime(ii,6*one_period)*MREprime(ii,6)),&
                         nint(s_nprime(ii,7*one_period)*MREprime(ii,7)) /)

    n_panel_nome(ii,1:7) = (/ nint(s_nprime(ii,one_period)),        nint(s_nprime(ii,2*one_period)),& 
                         nint(s_nprime(ii,3*one_period)),      nint(s_nprime(ii,4*one_period)),&
                         nint(s_nprime(ii,5*one_period)),      nint(s_nprime(ii,6*one_period)),&
                         nint(s_nprime(ii,7*one_period)) /)

    id_panel(ii,1:7)     = (/ s_id(ii,one_period),        s_id(ii,2*one_period),& 
                         s_id(ii,3*one_period),      s_id(ii,4*one_period),&
                         s_id(ii,5*one_period),      s_id(ii,6*one_period),&
                         s_id(ii,7*one_period) /)
 end do

 do j=1,7
    do i=1,7
       WHERE ( ( id_panel(:,j)  == i ) )
          n_panel_ub(:,j,i)         = n_panel(:,j)
          n_panel_nome_ub(:,j,i)    = n_panel_nome(:,j)
       ELSE WHERE
          n_panel_ub(:,j,i)         = 0
          n_panel_nome_ub(:,j,i)    = 0
       END WHERE
    end do
 end do

 n_panel_ub_U                   = n_panel_ub
 n_panel_nome_ub_U              = n_panel_nome_ub
 vec_n_panel_ub_U               = reshape(n_panel_ub_U,(/N*7*7,1/))
 vec_n_panel_nome_ub_U          = reshape(n_panel_nome_ub_U,(/N*7*7,1/))

   !
   ! calculate E(d log n) and V(d log n)
   !
 
 do i=2,7

   WHERE ( ( id_panel(:,i)  == 1 ) .and. ( id_panel(:,i-1)  == 1 ) .and. &
           ( n_panel_ub(:,i,1) > 0 ) .and. ( n_panel_ub(:,i-1,1) > 20 ) )
      diff(:,i-1)                       = log(real(n_panel_ub(:,i,1))) - log(real(n_panel_ub(:,i-1,1)))
      count_diff(:,i-1)                 = 1
   ELSE WHERE
      diff(:,i-1)                       = 0d0
      count_diff(:,i-1)                 = 0
   END WHERE

   vec_diff                             = reshape(diff,(/N*6,1/))
   vec_count_diff                       = reshape(count_diff,(/N*6,1/))

 end do

   m_ln = sum(vec_diff(:,1))/real(sum(vec_count_diff(:,1)))
   v_ln = sum((vec_diff(:,1)-m_ln)**2)/real(sum(vec_count_diff(:,1)))

   !
   ! calculate conditional bin
   !

do ii=1,N
   if (maxval(s_exitprime(ii,:)) == 1) then
      n_panel(ii,1:7)             = -1
      n_panel_nome(ii,1:7)        = -1
   else
      ! THEORY NO ME
      if ( ( n_panel(ii,1) < ncond ) .and. ( n_panel(ii,2) < ncond ) .and. ( n_panel(ii,3) < ncond ) .and. &
           ( n_panel(ii,4) < ncond ) .and. ( n_panel(ii,5) < ncond ) .and. ( n_panel(ii,6) < ncond ) ) then
         n_panel(ii,7)          = -1
      end if
      !
      if ( ( n_panel(ii,1) < ncond ) .and. ( n_panel(ii,2) < ncond ) .and. ( n_panel(ii,3) < ncond ) .and. &
           ( n_panel(ii,4) < ncond ) .and. ( n_panel(ii,5) < ncond ) ) then
         n_panel(ii,6)          = -1
      end if
      !
      if ( ( n_panel(ii,1) < ncond ) .and. ( n_panel(ii,2) < ncond ) .and. ( n_panel(ii,3) < ncond ) .and. &
           ( n_panel(ii,4) < ncond ) ) then
         n_panel(ii,5)          = -1
      end if
      !
      if ( ( n_panel(ii,1) < ncond ) .and. ( n_panel(ii,2) < ncond ) .and. ( n_panel(ii,3) < ncond ) ) then
         n_panel(ii,4)          = -1
      end if
      !
      if ( ( n_panel(ii,1) < ncond ) .and. ( n_panel(ii,2) < ncond ) ) then
         n_panel(ii,3)          = -1
      end if
      !
      if ( n_panel(ii,1) < ncond ) then
         n_panel(ii,2)          = -1
      end if
      !
      n_panel(ii,1)             = -1
      !
      ! WITH ME
      !
      if ( ( n_panel_nome(ii,1) < ncond ) .and. ( n_panel_nome(ii,2) < ncond ) .and. ( n_panel_nome(ii,3) < ncond ) .and. &
           ( n_panel_nome(ii,4) < ncond ) .and. ( n_panel_nome(ii,5) < ncond ) .and. ( n_panel_nome(ii,6) < ncond ) ) then
         n_panel_nome(ii,7)          = -1
      end if
      !
      if ( ( n_panel_nome(ii,1) < ncond ) .and. ( n_panel_nome(ii,2) < ncond ) .and. ( n_panel_nome(ii,3) < ncond ) .and. &
           ( n_panel_nome(ii,4) < ncond ) .and. ( n_panel_nome(ii,5) < ncond ) ) then
         n_panel_nome(ii,6)          = -1
      end if
      !
      if ( ( n_panel_nome(ii,1) < ncond ) .and. ( n_panel_nome(ii,2) < ncond ) .and. ( n_panel_nome(ii,3) < ncond ) .and. &
           ( n_panel_nome(ii,4) < ncond ) ) then
         n_panel_nome(ii,5)          = -1
      end if
      !
      if ( ( n_panel_nome(ii,1) < ncond ) .and. ( n_panel_nome(ii,2) < ncond ) .and. ( n_panel_nome(ii,3) < ncond ) ) then
         n_panel_nome(ii,4)          = -1
      end if
      !
      if ( ( n_panel_nome(ii,1) < ncond ) .and. ( n_panel_nome(ii,2) < ncond ) ) then
         n_panel_nome(ii,3)          = -1
      end if
      !
      if ( n_panel_nome(ii,1) < ncond ) then
         n_panel_nome(ii,2)          = -1
      end if
      !
      n_panel_nome(ii,1)             = -1
   end if
end do

vec_id_panel            = reshape(id_panel,(/N*7,1/))
vec_n_panel             = reshape(n_panel,(/N*7,1/))
vec_n_panel_nome        = reshape(n_panel_nome,(/N*7,1/))

bin_40t60_cond          = COUNT( (vec_n_panel >= 40 ) .AND. (vec_n_panel < 60) )
bin_40t46_cond          = COUNT( (vec_n_panel >= 40 ) .AND. (vec_n_panel <= 46) ) / bin_40t60_cond
bin_47t49_cond          = COUNT( (vec_n_panel >= 47 ) .AND. (vec_n_panel <= 49) ) / bin_40t60_cond
bin_50t52_cond          = COUNT( (vec_n_panel >= 50 ) .AND. (vec_n_panel <= 52) ) / bin_40t60_cond
bin_53t59_cond          = COUNT( (vec_n_panel >= 53 ) .AND. (vec_n_panel <= 59) ) / bin_40t60_cond

do ii=1,N
   do j=1,7
      ! THEORY NO ME
      if ( ( n_panel_ub(ii,1,j) < ncond ) .and. ( n_panel_ub(ii,2,j) < ncond ) .and. ( n_panel_ub(ii,3,j) < ncond ) .and. &
           ( n_panel_ub(ii,4,j) < ncond ) .and. ( n_panel_ub(ii,5,j) < ncond ) .and. ( n_panel_ub(ii,6,j) < ncond ) ) then
         n_panel_ub(ii,7,j)          = -1
      end if
      !
      if ( ( n_panel_ub(ii,1,j) < ncond ) .and. ( n_panel_ub(ii,2,j) < ncond ) .and. ( n_panel_ub(ii,3,j) < ncond ) .and. &
           ( n_panel_ub(ii,4,j) < ncond ) .and. ( n_panel_ub(ii,5,j) < ncond ) ) then
         n_panel_ub(ii,6,j)          = -1
      end if
      !
      if ( ( n_panel_ub(ii,1,j) < ncond ) .and. ( n_panel_ub(ii,2,j) < ncond ) .and. ( n_panel_ub(ii,3,j) < ncond ) .and. &
           ( n_panel_ub(ii,4,j) < ncond ) ) then
         n_panel_ub(ii,5,j)          = -1
      end if
      !
      if ( ( n_panel_ub(ii,1,j) < ncond ) .and. ( n_panel_ub(ii,2,j) < ncond ) .and. ( n_panel_ub(ii,3,j) < ncond ) ) then
         n_panel_ub(ii,4,j)          = -1
      end if
      !
      if ( ( n_panel_ub(ii,1,j) < ncond ) .and. ( n_panel_ub(ii,2,j) < ncond ) ) then
         n_panel_ub(ii,3,j)          = -1
      end if
      !
      if ( n_panel_ub(ii,1,j) < ncond ) then
         n_panel_ub(ii,2,j)          = -1
      end if
      !
      n_panel_ub(ii,1,j)             = -1
      !
      ! WITH ME
      !
      if ( ( n_panel_nome_ub(ii,1,j) < ncond ) .and. ( n_panel_nome_ub(ii,2,j) < ncond ) .and. ( n_panel_nome_ub(ii,3,j) < ncond ) &
        .and.  ( n_panel_nome_ub(ii,4,j) < ncond ) .and. ( n_panel_nome_ub(ii,5,j) < ncond ) &
        .and. ( n_panel_nome_ub(ii,6,j) < ncond ) ) then
         n_panel_nome_ub(ii,7,j)          = -1
      end if
      !
      if ( ( n_panel_nome_ub(ii,1,j) < ncond ) .and. ( n_panel_nome_ub(ii,2,j) < ncond ) .and. ( n_panel_nome_ub(ii,3,j) < ncond ) &
           .and. ( n_panel_nome_ub(ii,4,j) < ncond ) .and. ( n_panel_nome_ub(ii,5,j) < ncond ) ) then
         n_panel_nome_ub(ii,6,j)          = -1
      end if
      !
      if ( ( n_panel_nome_ub(ii,1,j) < ncond ) .and. ( n_panel_nome_ub(ii,2,j) < ncond ) .and. ( n_panel_nome_ub(ii,3,j) < ncond ) & 
        .and. ( n_panel_nome_ub(ii,4,j) < ncond ) ) then
         n_panel_nome_ub(ii,5,j)          = -1
      end if
      !
      if ( ( n_panel_nome_ub(ii,1,j) < ncond ) .and. ( n_panel_nome_ub(ii,2,j) < ncond ) &
        .and. ( n_panel_nome_ub(ii,3,j) < ncond ) ) then
         n_panel_nome_ub(ii,4,j)          = -1
      end if
      !
      if ( ( n_panel_nome_ub(ii,1,j) < ncond ) .and. ( n_panel_nome_ub(ii,2,j) < ncond ) ) then
         n_panel_nome_ub(ii,3,j)          = -1
      end if
      !
      if ( n_panel_nome_ub(ii,1,j) < ncond ) then
         n_panel_nome_ub(ii,2,j)          = -1
      end if
      !
      n_panel_nome_ub(ii,1,j)             = -1
   end do
end do

vec_n_panel_ub             = reshape(n_panel_ub,(/N*7*7,1/))
vec_n_panel_nome_ub        = reshape(n_panel_nome_ub,(/N*7*7,1/))

bin_40t60_cond_ub          = COUNT( (vec_n_panel_ub >= 40 ) .AND. (vec_n_panel_ub < 60) )
bin_40t46_cond_ub          = COUNT( (vec_n_panel_ub >= 40 ) .AND. (vec_n_panel_ub <= 46) ) / bin_40t60_cond_ub
bin_47t49_cond_ub          = COUNT( (vec_n_panel_ub >= 47 ) .AND. (vec_n_panel_ub <= 49) ) / bin_40t60_cond_ub
bin_50t52_cond_ub          = COUNT( (vec_n_panel_ub >= 50 ) .AND. (vec_n_panel_ub <= 52) ) / bin_40t60_cond_ub
bin_53t59_cond_ub          = COUNT( (vec_n_panel_ub >= 53 ) .AND. (vec_n_panel_ub <= 59) ) / bin_40t60_cond_ub

   !
   ! AUXILIARY PARAMETERS AND OBJECTIVE FUNCTION
   !

theoreticalmoments = (/ m_ln, sqrt(v_ln),&
     bin_40t46/7d0, bin_47t49/3d0, bin_50t52/3d0, bin_53t59/7d0,&
     -beta1*(1-alpha)+1,&
     bin_40t46_cond_ub/7d0, bin_47t49_cond_ub/3d0, bin_50t52_cond_ub/3d0, bin_53t59_cond_ub/7d0 /)

empiricalmoments = (/0.0082d0,0.1560d0,0.0718d0,0.0790d0,0.0307d0,0.0240d0,&
                      2.2522d0,0.0284d0,0.0519d0,0.0457d0,0.0726d0 /)

if (weightmatrix == 1) then

 v_aps   = (/ 0.00006450d0, 0.00014801d0,&
              0.00076948d0, 0.00080393d0, 0.00051417d0, 0.00045658d0,&
              0.0056d0,&
              0.00156101d0, 0.00208589d0, 0.00196350d0, 0.00243968d0 /)

else
   v_aps           = 1
end if

residuals       = 0d0

   DO i=1,naps
      residuals = residuals + &
                  ( (theoreticalmoments(i)-empiricalmoments(i))/v_aps(i) )**2 
   END DO

   DO i=1,naps
      if ( wfig == 1 ) then
         WRITE(*,*) 'aps #', i, 'theory ', theoreticalmoments(i), 'data ', empiricalmoments(i)
      end if
   END DO

   func  = residuals

write(*,"(I7,19f18.6)") int_rn, theta(:),&
                        theoreticalmoments(:),&
                        func

12345 CONTINUE

CONTAINS

  ! --------------------------------------------------------------------

  REAL FUNCTION FOC_residual(z, alpha, cf, lambda, mu_z, nbar, uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage, dum1,dum2)
    IMPLICIT NONE

    !
    ! compute the residual of the FOC for oz and hz
    ! dum1: for oz, zdet or hz
    ! dum2: residual or derivative

    REAL(8), INTENT(IN)     :: z, alpha, cf, lambda, mu_z, nbar, uz, oz, r, sigma_z,F, tau_cf, tau_wage, wage 
    INTEGER                 ::  dum1, dum2
    REAL(8)                 :: R1
    REAL(8)                 :: pi_below, pi_at, pi_above, resid_nosunk, resid, resid_det, resid_sto    

    !solve for the optimal threshold in the following situation
    !dum == 1: no sunk cost, this is just oz
    !dum == 2: deterministic case
    !dum == 3: stochastic case with a sunk cost

    R1          = - ( mu_z + sqrt(mu_z**2 + 2 * (r+lambda) * sigma_z**2) ) / sigma_z**2

    IF ( dum2 == 1 ) THEN 
       ! residual
       pi_at       = exp(z) * nbar**alpha - wage*nbar - cf 
       pi_above    = exp( z /(1-alpha) ) * (alpha / ( wage*(1+tau_wage) ) )**( alpha/(1-alpha) ) * ( 1 - alpha )&                    
            - cf*(1+tau_cf) 
      IF ( dum1 == 1 ) THEN       
       resid_nosunk    = pi_above - pi_at
       resid           = resid_nosunk
      ELSE         
         IF ( dum1 == 2 ) THEN
            resid_det   = pi_above - pi_at - (r+lambda)*F
            resid       = resid_det
         ELSE
            resid_sto   = -R1*exp(z*R1)*&
                       ( (exp(z-z*R1)-exp(oz-oz*R1))*(nbar**alpha)/(-1+R1)&
                       + cf*tau_cf*(exp(-z*R1)- exp(-oz*R1))/R1&
                       - ( exp(-z*R1) - exp(-oz*R1) )*nbar*wage/R1&
                       - ( ((-1+alpha)**2)*exp((z+oz)*(1+(-1+alpha)*R1)/(1-alpha))&
                       * ( exp( z * (1+(-1+alpha) * R1) / (-1+alpha) )&
                       - exp( oz * (1+(-1+alpha) * R1) /(-1+alpha)) )&
                       * ( alpha / ( wage + tau_wage * wage) )**(alpha/(1-alpha)) )&
                       /(1+(-1+alpha) * R1) )&
                       - (r+lambda)*F ; 
            resid        = resid_sto ;

         END IF
      END IF
   ELSE  
      ! jacobian
      IF ( dum1 < 3 ) THEN
         resid       = -exp(z)*(nbar**alpha) + exp(z/(1 - alpha))*(alpha/((1 + tau_wage)*wage))**(alpha/(1 - alpha))
      ELSE
         resid_sto   = ( (-1 + alpha)*exp(z/(1 - alpha))*R1&
                    *( 1 + (-1 + alpha)*exp( (z-oz)*(1+(-1+alpha)*R1)/(-1 +alpha))*R1)&
                    *(alpha/(wage + tau_wage*wage))**(alpha/(1 - alpha)) )&
                    /(1 + (-1 + alpha)*R1)& 
                    + ( exp(-oz*R1)*( (nbar**alpha)*R1*(-exp(z + oz*R1) + exp(oz+z*R1)*R1)&
                    + exp(z*R1)*(-1+R1)*R1*(cf*tau_cf - nbar*wage)))/(-1 + R1)
          resid        = resid_sto ;    
       END IF
    END IF

    FOC_residual = resid

  END FUNCTION FOC_residual

  ! --------------------------------------------------------------------

  REAL FUNCTION invcdf_residual(z, beta1, beta2, hz, y, z0,dum)
    IMPLICIT NONE

    !
    ! inverse cdf residual
    ! dum = 1: compute the residual
    ! dum = 2: compute the jacobian

    REAL(8), INTENT(IN)     :: z, beta1, beta2, hz, y, z0
    INTEGER              :: dum

    IF ( dum == 1) THEN
       invcdf_residual = ( (1 - exp( -z0*beta1 + hz*(beta1-beta2) + z*beta2) ) * beta1&
            + ( -1 + exp( (z-z0)*beta1 ) ) * beta2 ) / ( beta1 - beta2 ) - y
    ELSE 
       invcdf_residual = ( exp( (z-z0)*beta1 ) - exp( -z0*beta1 + hz*(beta1-beta2) + z*beta2) )&
            * beta1 * beta2 / ( beta1 - beta2 )
    END IF

  END FUNCTION invcdf_residual

  ! --------------------------------------------------------------------
  ! INTEGER FUNCTION  LookUp_firstg():
  ! x sorted array of size Size
  ! Data key value
  ! LookUp_firstg find the index of the first x that is strictly greater than Data
  !  otherwise, it returns 0.
  ! --------------------------------------------------------------------

  INTEGER FUNCTION  LookUp_firstg(x, Size, Data)
    IMPLICIT  NONE
    INTEGER, INTENT(IN)                    :: Size
    REAL(8), DIMENSION(1:SIZE), INTENT(IN)    :: x
    REAL(8), INTENT(IN)                    :: Data
    INTEGER                                :: i

    LookUp_firstg = 0                        ! assume not found
    DO i = 1, Size                    ! check each array element
       IF (x(i) > Data) THEN         !   is it equal to Data?
          LookUp_firstg = i           !   YES, found.  Record location
          EXIT                        !   and bail out
       END IF
    END DO
  END FUNCTION  LookUp_firstg

  ! --------------------------------------------------------------------
  ! INTEGER FUNCTION  LookUp_lastleq():
  ! x sorted array of size Size
  ! Data key value
  ! LookUp_firstg find the index of the last x that is leq than Data
  !  otherwise, it returns 0.
  ! --------------------------------------------------------------------

  INTEGER FUNCTION  LookUp_lastleq(x, Size, Data)
    IMPLICIT  NONE
    INTEGER, INTENT(IN)                    :: Size
    REAL(8), DIMENSION(1:SIZE), INTENT(IN)    :: x
    REAL(8), INTENT(IN)                    :: Data
    INTEGER                                :: i

    LookUp_lastleq = 0                        ! assume not found
    DO i = 1, Size                    ! check each array element
       IF (x(i) > Data) THEN          !   is it equal to Data?
          LookUp_lastleq = max(i-1,1)  !   YES, found.  Record location
          EXIT                        !   and bail out
       END IF
    END DO
  END FUNCTION  LookUp_lastleq

! --------------------------------------------------------------------
  logical function isnan(x)
    IMPLICIT NONE
    REAL(8)                                 :: x
    isnan = .true.
    If(x .ge. 0.0) then
       isnan = .false.
    elseif (x .le. 0.0) then
       isnan = .false.
    endif

  end function isnan

!--------------------------------------------------------------------

end subroutine objfun
