
clear all ; close all ; clc ;

global prec prec2

% model_to_use = 0 ;
nummodel = 1 ;
% rem = 1 ;

  AS = [0.0301	0.0030	0.0520	0.0211	1.0281	0.0004
    0.0293	0.0029	0.0527	0.0134	1.2908	0
    0.0302	0.0032	0.0504	0.0324	0	0.0015
    0.0296	0.0013	0.0230	0.0177	0.4516	0.0001
    0.0300	0.0044	0.0766	0.0210	1.4634	0.0004    
    0.0211	0.0020	0.0416	0.0218	0.9021	0.0004
    0.0230	0.0011	0.0291	0.0148	0.6059	0.0001
    0.0276	0.0025	0.0480	0.0270	0.9475	0.0008
    0.0226	0.0015	0.0370	0.0483	0.8959	0.0002] ;

    ALPHAvec = [0.66,0.66,0.66,0.85,0.50,0.69,0.78,0.66,0.74] ;
    
    paramcompSUNK = AS(:,5) ;
    paramcompTAU = AS(:,6) ;
    paramcompLAMBDA = AS(:,1) ;
    paramcompMU = AS(:,2) ;
    paramcompSIGMA = AS(:,3) ;
    paramcompMRE = AS(:,4) ;
    
    r                                   = 0.05 ;
    nbar                                = 49.01 ;
    wage                                = 1 ;
    cf                                  = 0 ;
    tau.cf                              = 0 ;
    alpha                               = ALPHAvec(nummodel) ;
    
        lambda                          = paramcompLAMBDA(nummodel) ;
        sigma.z                         = paramcompSIGMA(nummodel) ;
        mu.z                            =  paramcompMU(nummodel) ;
        tau.wage                        = paramcompTAU(nummodel) ;
        sunkcost                        = paramcompSUNK(nummodel) ;
        
        sigma.mre = paramcompMRE(nummodel) ;
    
    taux.wage= 0 ; taux.cf = 0 ;sunkcostx = 0 ;
    % for experiment: pushing the threshold to 75
    nbarbar = 74.01 ;
    
    % precision for calculation:
    prec = 1e-13 ;
    prec2 = 1e-7 ;
  
    
targetnoverm1 = 7.5 ;

paramEC = [1e-5,.001,.01,.02,.03,.05,.1,.15,.2,.25,.5,1];

for xs2=1:length(paramEC) ;
    
    disp('============================================================================')
    disp('Experiment GE, Elastic Entry, log utility, elastic labor')
    for rem=1;
        phi = 1 ; %  Elasticity ;
        targetN = .25 ; Ebar = .05 ; entrycostV = paramEC(xs2) ; tg = 0 ;
        targetwage = 1 ; targetnoverm = 7.5 ;
        calibEEELrrr ;
        disp('z0')
        z0
        disp('B:')
        B
        disp('mean distribution of entry cost (not actually paid!!!!)')
        entrycostM
        disp(xs2)
        eqBF = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        eqAF = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        tg = tau.wage ;
        eqAF2 = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM+sunkcost,entrycostV,Ebar,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        tg = 0 ;
        eqAF3 = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbarbar,tau,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);
        eq_wtaxonly = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbar,tau,tg,lambda,r,cf,sigma,mu,sunkcostx,z0,rem);
        eq_wsunkonly = GEcalcELASTICENTRY_ELASTICLABOR(entrycostM,entrycostV,Ebar,phi,B,alpha,nbar,taux,tg,lambda,r,cf,sigma,mu,sunkcost,z0,rem);

%         dispresults
%         per_e6(:,:,rem+1) = per ;
%         eval(strcat('save MMres_exp6_',strcat(strcat(strcat(num2str(model_to_use),'_'),num2str(rem)),strcat('_',num2str(xs2)))));
            resultsPECS = eqAF./eqBF*100-100 ;

eval(strcat(strcat('save resultsFIG8',num2str(xs2)),' resultsPECS' ))

    end
end
disp('================================================')
disp('finished')




clear all ;

paramEC = [1e-5,.001,.01,.02,.03,.05,.1,.15,.2,.25,.5,1];


AAAA = [] ;
model_to_use = 0 ; 
rem = 1 ;
resultsPECSK = [] ; 
for xs2=1:length(paramEC)
    eval(strcat('load resultsFIG8',num2str(xs2)))
    resultsPECSK(xs2,:) = resultsPECS ; % = [AAAA;per_e6(1,1,2),per_e6(2,1,2),per_e6(4,1,2), per_e6(5,1,2), per_e6(3,1,2)] ;
end


paramvec = paramEC' ;


figure ;
subplot(2,1,1);plot(paramvec,resultsPECSK(:,1),'b-','LineWidth',2)
title('Effect of Removing the Regulation: (1) Output','LineWidth',2,'Fontsize',14) ;
ylabel('%','Fontsize',14); grid on ;  axis tight ;
set(gca,'Fontsize',13) ; 

subplot(2,1,2);plot(paramvec,resultsPECSK(:,3),'b-','LineWidth',2)
title('(2) Number of Firms','LineWidth',2,'Fontsize',14) ;
ylabel('%','Fontsize',14); grid on ; axis tight ;
xlabel('Heterogeneity in entry cost: \sigma_v','Fontsize',14)
set(gca,'Fontsize',13) ; 
print -depsc2  PEcompstat.eps

