
clear all ; close all ; clc ;

format bank

for jss=1
    
    
    % jss is the model #
    % model, calculated by file PEprogramfinal2013R
    % 1 = full; 2 = sunk cost only ; 3 = tax only ; 4 = high alpha; 5 = low
    % alpha ; 6 = manuf ; 7 = construction; 8 = retail; 9 = lodging and
    % resturant
    
    eval(strcat('load resultsFX',num2str(jss))) ;
    
    
    % note: the equilibrium output is eq = [Y,N,M,wage,lambda*entrycost*M,Pi,C] ;
    xs = [1,2,3,4,7] ;
    
    disp('------------------------------------------------------')
    disp('First: simple table for the paper')
    disp('Note: this table applies to real resource costs')
    disp('------------------------------------------------------')
    disp('\begin{table} ')
    disp('\begin{centering} ')
    disp('\begin{tabular}{llllll|lllll}')
    disp('Experiment & $Y$ & $N$ & $M$ & $w$ & $C$  \tabularnewline ')
    disp('\hline ')
    X1 = resultsPE.inelasticlabor.realcost.entryfixed.basic(xs) ;
    disp([' inelastic labor and inelastic entry ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.entryfixed.basic(xs) ;
    disp([' elastic labor and inelastic entry ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.realcost.basic(xs) ;
    disp([' inelastic labor and elastic entry ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.basic(xs) ;
    disp([' elastic labor and elastic entry ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    disp('\end{tabular} ')
    disp('\par\end{centering} ')
    disp('\caption{Policy Experiments} ')
    disp('\end{table} ')
    
    disp('------------------------------------------------------')
    disp('Second: more experiments, for discussion')
    disp('------------------------------------------------------')
    disp('\begin{table} ')
    disp('\begin{centering} ')
    disp('\begin{tabular}{llllll|lllll}')
    disp('Experiment & $Y$ & $N$ & $M$ & $w$ & $C$  \tabularnewline ')
    disp('\hline ')
    X1 = resultsPE.elasticlabor.realcost.basic(xs) ;
    disp([' Benchmark (Same as line 4 Tab 1)','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.transfers.basic(xs) ;
    disp([' Transfers ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.entrycostlabor.elasticlabor.realcost.basic (xs) ;
    disp([' Entry cost in labor terms ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.applyall(xs) ;
    disp([' Apply to All ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.apply75(xs) ;
    disp([' Apply to Above 75 ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.removetaxonly(xs) ;
    disp([' Remove Tax Only  ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.transfers.removetaxonly(xs) ;
    disp([' Remove Tax Only (transfers)  ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.realcost.removesunkcostonly(xs) ;
    disp([' Remove Sunk Cost Only  ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.elasticlabor.transfers.removesunkcostonly(xs) ;
    disp([' Remove Sunk Cost Only  (transfers) ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    disp('\end{tabular} ')
    disp('\par\end{centering} ')
    disp('\caption{Policy Experiments 2} ')
    disp('\end{table} ')
    
    
    disp('------------------------------------------------------------------')
    disp('Third: more experiments, for discussion (but now fixed # of firms'    )
    disp('------------------------------------------------------------------')
    disp('\begin{table} ')
    disp('\begin{centering} ')
    disp('\begin{tabular}{llllll|lllll}')
    disp('Experiment & $Y$ & $N$ & $M$ & $w$ & $C$  \tabularnewline ')
    disp('\hline ')
    X1 = resultsPE.inelasticlabor.realcost.entryfixed.basic(xs) ;
    disp([' Benchmark (Same as line 1 Tab 1)','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.realcost.pepe(xs) ;
    disp([' Holding wage fixed','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.transfers.entryfixed.basic(xs) ;
    disp([' Transfers ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.realcost.entryfixed.applyall(xs) ;
    disp([' Apply to All ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.realcost.entryfixed.apply75(xs) ;
    disp([' Apply to Above 75 ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.transfers.entryfixed.removetaxonly(xs) ;
    disp([' Remove Tax Only  ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    X1 = resultsPE.inelasticlabor.transfers.entryfixed.removesunkcostonly ;
    disp([' Remove Sunk Cost Only  ','&',num2str(X1(1),'% 1.3f'),'&',num2str(X1(2),'% 1.3f'),'&',num2str(X1(3),'% 1.3f'),'&',num2str(X1(4),'% 1.3f'),'&',num2str(X1(5),'% 1.3f'),'& \tabularnewline '])
    disp('\end{tabular} ')
    disp('\par\end{centering} ')
    disp('\caption{Policy Experiments 3} ')
    disp('\end{table} ')
    
end

format short